#ifndef __BTCTL_H__
#define __BTCTL_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <glib-object.h>

#define BTCTL(obj)          G_TYPE_CHECK_INSTANCE_CAST (obj, btctl_get_type (), Btctl)
#define BTCTL_CLASS(klass)  G_TYPE_CHECK_CLASS_CAST (klass, btctl_get_type (), BtctlClass)
#define IS_BTCTL(obj)       G_TYPE_CHECK_INSTANCE_TYPE (obj, btctl_get_type ())

typedef struct _Btctl		Btctl;
typedef struct _BtctlClass	BtctlClass;

struct _Btctl
{
  GObject obj;
  gint    ctl; /* hci device */
};

struct _BtctlClass
{
  GObjectClass	parent_class;
  void (*add_device) (Btctl *bc);
  void (*device_name) (Btctl *bc);
  void (*status_change) (Btctl *bc);
  void (*add_device_service) (Btctl *bc);
};

/* Gtk housekeeping methods */

guint	btctl_get_type	(void);
GObject*	btctl_new	(void);
void	btctl_clear	(Btctl *bc);

/* fields for status */

enum {
	BTCTL_STATUS_NONE,
	BTCTL_STATUS_ERROR,
	BTCTL_STATUS_SCANNING,
	BTCTL_STATUS_GETTING_NAMES,
	BTCTL_STATUS_COMPLETE,
	BTCTL_STATUS_GETTING_SERVICES,
	BTCTL_STATUS_LAST
};

#define BTCTL_RFCOMM_NO_DEVICE -1
#define BTCTL_RFCOMM_DEVICE_IN_USE -2

/* public methods */

void btctl_discover_devices(Btctl *bc);
void btctl_list_rfcomm_connections(Btctl *bc);
gint btctl_establish_rfcomm_connection(Btctl *bc, gchar *bdstr, guint channel);
gint btctl_get_established_rfcomm_connection(Btctl *bc, gchar *bdstr, 
											guint channel);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __BTCTL_H__ */
